//@author: catweasel
//@help: Match Velocity
//@tags: boids, dx11
//@credits: 



struct particle
{
	float3 pos;
	float3 vel;
};
RWStructuredBuffer<particle> Output : BACKBUFFER;

float accel=1;
int total;
float atraction=1;
float3 centre;
//==============================================================================
//COMPUTE SHADER ===============================================================
//==============================================================================

[numthreads(64, 1, 1)]
void CSConstantForce( uint3 DTid : SV_DispatchThreadID )
{

	{

		float3 c=0;
		for( uint i = 0; i < total; i++ )
			{
			if (DTid.x != i)
				{
				
				c += (Output[i].vel+Output[DTid.x].vel)*accel;;
				
				}
			
			c=c/(total-1); //get average positon of all boids
			
			}
		c+=centre;
	//	Output[DTid.x].vel = Output[DTid.x].pos;
		Output[DTid.x].pos += (Output[DTid.x].vel-c)/atraction;
	//	Output[DTid.x].vel = Output[DTid.x].vel-Output[DTid.x].pos;
	}
	
}



//==============================================================================
//TECHNIQUES ===================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CSConstantForce() ) );
	}
}
